#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netdb.h>
#include <arpa/inet.h>

#define REUSEADDR       1
#define LISTEN_BACKLOG  10

int GetAddrInfo(char* _addr, 
                char* _port, 
                struct addrinfo* _hints, 
                struct addrinfo** _result);
int loopNewSocket(int _domain, int _type, int _protocol);
int loopSetSockOpt(int _sockfd, int _level, int _optname, 
               void* _optval, socklen_t _optlen);
int loopBind(int _sockfd, struct sockaddr* _addr, socklen_t _len);
int loopListen(int _sockfd, int _backlog);
int loopAccept(int _sockfd, struct sockaddr* _addr, socklen_t* _addrlen);
ssize_t loopSend(int _sockfd, void* _buff, size_t _buffsize, int _flags);